% DATA_ID1   State-space realisation of continuous-time MIMO filters
% 
% 	     Input:
%		     y1(t), ..., yn(t), u1(t), ..., um(t)
% 	     Output:
%          y(t), y'(t), y''(t) ..., u(t), u'(t), ...

% Calculation of the denominator with multiple time constant tc
den=1;
for i=1:men,
   den=conv([tc 1],den);
end;
a=fliplr(den(2:men+1)/den(1));

% State-space realisation of the output filter

A0=zeros(out*(men-1),out);
A1=eye(out*(men-1));
for i=1:men
   A2(1:out,out*(i-1)+1:i*out)=-a(i)*eye(out);
end
Ay=[A0 A1;A2];
B0=zeros(out*(men-1),out);
B1=eye(out,out);
By=[B0;B1];

C0=-eye(out*(men-1)+out);C0(1:out,1:out)=eye(out);
for i=1:men
   C1(1:out,out*(i-1)+1:i*out)=a(i)*eye(out);
end
Cy=[C0;C1]/den(1);
Dy=-[zeros(out,out);By]/den(1);

% State-space realisation of the input filter

a0=zeros(in*(men-1),in);
a1=eye(in*(men-1));
for i=1:men
   a2(1:in,in*(i-1)+1:i*in)=-a(i)*eye(in);
end
Au=[a0 a1;a2];
b0=zeros(in*(men-1),in);
b1=eye(in,in);
Bu=[b0;b1];
if cit==men
   
   c0=eye(in*(cit-1)+in);
   for i=1:cit
      c1(1:in,in*(i-1)+1:i*in)=-a(i)*eye(in);
   end
   Cu=[c0;c1]/den(1);
   Du=[zeros(in*(cit-1)+in,in);eye(in)]/den(1);
else
   c0=eye(in*(cit+1));
   c1=zeros(in*(cit+1),(men-cit-1)*in);
   Cu=[c0 c1]/den(1);
   Du=zeros(in*(cit+1),in);
end