% DATA_ID2   State-space realisation of discete-time MIMO filters
% 
%       Input:
%		     y1(k), ..., yn(k), u1(k), ..., um(k)
%       Output:
%		     y(k), y(k-1), y(k-2) ..., u(k-1-Ds), ...

% State-space realisation of the output filter

A0=zeros(men*out);
A0(out+1:men*out,1:(men-1)*out)=eye((men-1)*out);
Ay=A0;

B0=-eye(out);
B1=zeros((men-1)*out,out);
By=[B0;B1];

C0=zeros(out,men*out);
C1=eye(men*out);
Cy=[C0;C1];

D1=eye(out);
D2=zeros(men*out,out);
Dy=[D1;D2];

% State-space realisation of the input filter

a0=zeros(in,(cit+Ds)*in);
a1=eye((cit+Ds-1)*in);
a2=zeros((cit+Ds-1)*in,in);
Au=[a0;[a1 a2]];

b0=eye(in);
b1=zeros((cit+Ds-1)*in,in);
Bu=[b0;b1];

c0=zeros(cit*in,Ds*in);
c1=eye(cit*in);
Cu=[c0 c1];

Du=zeros(cit*in,in);
